/* -------------------------------------------------------------------------- *\
   Project..........:   eXtreme Geometric Environment for PLaSM
   Copyright........:   Universita' degli studi di ROMA TRE
                        Dipartimento di Informatica e Automazione 
                        Via Vasca Navale 84, 00146 ROMA
	Development by...:	Simone Portuesi
	Environment......:	Win32, UNIX
\* -------------------------------------------------------------------------- */




#ifndef _C_2_SCHEME_H__
#define _C_2_SCHEME_H__

#include <scheme.h>

#if MZSCHEME_VERSION_MAJOR<=208

#define SCHEME_BYTE_STRINGP(a) SCHEME_STRINGP(a)
#define SCHEME_BYTE_STR_VAL(a) SCHEME_STR_VAL(a)
#define scheme_byte_string_to_char_string(a) (a)
#define scheme_make_byte_string(a) scheme_make_string(a)

#define SCHEME_CHAR_STRINGP(a) SCHEME_STRINGP(a)
#define SCHEME_CHAR_STR_VAL(a) SCHEME_STR_VAL(a)
#define scheme_char_string_to_byte_string(a) (a)
#define scheme_make_char_string(a) scheme_make_string(a)

#endif

Scheme_Object* string_to_symbol_ci(int argc, Scheme_Object **argv);

Scheme_Object* Scheme_Str_Call (const char *s_func, const char *s_arg);

Scheme_Object* Scheme_SR_Table_0 (int rule);
Scheme_Object* Scheme_SR_Table_1 (int rule, Scheme_Object *arg1);
Scheme_Object* Scheme_SR_Table_2 (int rule, Scheme_Object *arg1, Scheme_Object *arg2);
Scheme_Object* Scheme_SR_Table_3 (int rule, Scheme_Object *arg1, Scheme_Object *arg2, Scheme_Object *arg3);
Scheme_Object* Scheme_SR_Table_4 (int rule, Scheme_Object *arg1, Scheme_Object *arg2, Scheme_Object *arg3,Scheme_Object *arg4);
Scheme_Object* Scheme_SR_Table_5 (int rule, Scheme_Object *arg1, Scheme_Object *arg2, Scheme_Object *arg3,Scheme_Object *arg4, Scheme_Object *arg5);
Scheme_Object* Scheme_SR_Table_6 (int rule, Scheme_Object *arg1, Scheme_Object *arg2, Scheme_Object *arg3,Scheme_Object *arg4, Scheme_Object *arg5, Scheme_Object *arg6);
Scheme_Object* Scheme_SR_Table_7 (int rule, Scheme_Object *arg1, Scheme_Object *arg2, Scheme_Object *arg3,Scheme_Object *arg4, Scheme_Object *arg5, Scheme_Object *arg6, Scheme_Object *arg7);

#endif

