#ifndef _XCGLUE_H__
#define _XCGLUE_H__


#include <scheme.h>

#if MZSCHEME_VERSION_MAJOR<=208

#define SCHEME_BYTE_STRINGP(a) SCHEME_STRINGP(a)
#define SCHEME_BYTE_STR_VAL(a) SCHEME_STR_VAL(a)
#define scheme_byte_string_to_char_string(a) (a)
#define scheme_make_byte_string(a) scheme_make_string(a)

#define SCHEME_CHAR_STRINGP(a) SCHEME_STRINGP(a)
#define SCHEME_CHAR_STR_VAL(a) SCHEME_STR_VAL(a)
#define scheme_char_string_to_byte_string(a) (a)
#define scheme_make_char_string(a) scheme_make_string(a)

#endif


#define OBJSCHEME_GET_CPP_OBJ(obj) scheme_struct_ref(obj, 0)
#define OBJSCHEME_SET_CPP_OBJ(obj, v) scheme_struct_set(obj, 0, v)

/* Forward declarations (documented further below) */
void objscheme_init();
void objscheme_add_procedures(Scheme_Env *);
Scheme_Object *objscheme_make_class(const char *name, Scheme_Object *sup, Scheme_Prim *initf, int num_methods);
Scheme_Object *objscheme_add_method_w_arity(Scheme_Object *c, const char *name, Scheme_Prim *f, int mina, int maxa);
Scheme_Object *objscheme_make_uninited_object(Scheme_Object *sclass);
Scheme_Object *objscheme_find_method(Scheme_Object *obj, char *name, void **cache);
int objscheme_is_a(Scheme_Object *o, Scheme_Object *c);


#endif //_XCGLUE_H__


