#ifndef _XML2DPATH_CONVERT_H__
#define _XML2DPATH_CONVERT_H__

#include "generaldef.h"
#include <map>

#include "rayshooting.h"
#include "bsp.h"
#include "ggraph.h"

#define NUM_FACES_USE_QUAD 30


extern std::map<key,key> full_to_which;
extern std::map<key,key> cut_to_full;
extern std::map<key,key> cut_to_src;


void brep_convert(RayShooting2d* rs,
						bsp* b,key N,
						ggraph* grep,key Frep,
						ggraph* gfull,key Cfull,
						float x1=-1,float y1=-1,float x2=+1,float y2=+1,
						int nrec=0,
						float tolerance=1e-4);

#endif //_XML2DPATH_CONVERT_H__



